// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.technical.optimization.vessel;

import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import java.io.Serializable;
import java.util.Date;

/**
 * Temporary table, use to compute DenormalizedVessel table (see mantis #25846)
 */
// HibernateEntity.vsl annotations merge-point
public abstract class TempDenormalizedVessel
    implements Serializable, Comparable<TempDenormalizedVessel>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -4555888565958794560L;

    // Generate 4 attributes
    private String code;

    /**
     * 
     * @return this.code String
     */
    public String getCode()
    {
        return this.code;
    }

    /**
     * 
     * @param codeIn String
     */
    public void setCode(String codeIn)
    {
        this.code = codeIn;
    }

    private Date vrpStartDateTime;

    /**
     * 
     * @return this.vrpStartDateTime Date
     */
    public Date getVrpStartDateTime()
    {
        return this.vrpStartDateTime;
    }

    /**
     * 
     * @param vrpStartDateTimeIn Date
     */
    public void setVrpStartDateTime(Date vrpStartDateTimeIn)
    {
        this.vrpStartDateTime = vrpStartDateTimeIn;
    }

    private Date vfStartDateTime;

    /**
     * 
     * @return this.vfStartDateTime Date
     */
    public Date getVfStartDateTime()
    {
        return this.vfStartDateTime;
    }

    /**
     * 
     * @param vfStartDateTimeIn Date
     */
    public void setVfStartDateTime(Date vfStartDateTimeIn)
    {
        this.vfStartDateTime = vfStartDateTimeIn;
    }

    private Date vopStartDateTime;

    /**
     * 
     * @return this.vopStartDateTime Date
     */
    public Date getVopStartDateTime()
    {
        return this.vopStartDateTime;
    }

    /**
     * 
     * @param vopStartDateTimeIn Date
     */
    public void setVopStartDateTime(Date vopStartDateTimeIn)
    {
        this.vopStartDateTime = vopStartDateTimeIn;
    }

    // Generate 1 associations
    private Program program;

    /**
     * Programme d'observation à l'origine d'une collecte de données.
     * Désigne les activités qui sont à l'origine de la collecte d'un ensemble cohérent de données,
     * que ce
     * soit pour des collectes continues (marées observées en mer, SIPA) ou pour des études limitées
     * dans
     * le temps. La quantité de données rattachées à un programme peut être variable, selon qu'il
     * s'agit
     * d'une activité longue ou intensive, ou d'une opération plus ponctuelle (étude) mais toujours
     * mise en
     * œuvre selon un schéma décidé à l'avance.
     * Exemple de programmes d'observations :
     * - SIH-OBSMER (marées observées en mer)
     * - SIH-STATPECHE (enquete d'activité et d'effort...)
     * - SIPA : données déclaratives transmises par la DPMA
     * - VMS : données satellitaires
     * - OFIMER : données du SI de l'OFIMER
     * @return this.program Program
     */
    public Program getProgram()
    {
        return this.program;
    }

    /**
     * Programme d'observation à l'origine d'une collecte de données.
     * Désigne les activités qui sont à l'origine de la collecte d'un ensemble cohérent de données,
     * que ce
     * soit pour des collectes continues (marées observées en mer, SIPA) ou pour des études limitées
     * dans
     * le temps. La quantité de données rattachées à un programme peut être variable, selon qu'il
     * s'agit
     * d'une activité longue ou intensive, ou d'une opération plus ponctuelle (étude) mais toujours
     * mise en
     * œuvre selon un schéma décidé à l'avance.
     * Exemple de programmes d'observations :
     * - SIH-OBSMER (marées observées en mer)
     * - SIH-STATPECHE (enquete d'activité et d'effort...)
     * - SIPA : données déclaratives transmises par la DPMA
     * - VMS : données satellitaires
     * - OFIMER : données du SI de l'OFIMER
     * @param programIn Program
     */
    public void setProgram(Program programIn)
    {
        this.program = programIn;
    }

    /**
     * Returns <code>true</code> if the argument is an TempDenormalizedVessel instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof TempDenormalizedVessel))
        {
            return false;
        }
        final TempDenormalizedVessel that = (TempDenormalizedVessel)object;
        if (this.code == null || that.getCode() == null || !this.code.equals(that.getCode()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.code == null ? 0 : this.code.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link TempDenormalizedVessel}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link TempDenormalizedVessel}.
         * @return new TempDenormalizedVesselImpl()
         */
        public static TempDenormalizedVessel newInstance()
        {
            return new TempDenormalizedVesselImpl();
        }

        /**
         * Constructs a new instance of {@link TempDenormalizedVessel}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param vrpStartDateTime Date
         * @param program Program
         * @return newInstance
         */
        public static TempDenormalizedVessel newInstance(Date vrpStartDateTime, Program program)
        {
            final TempDenormalizedVessel entity = new TempDenormalizedVesselImpl();
            entity.setVrpStartDateTime(vrpStartDateTime);
            entity.setProgram(program);
            return entity;
        }

        /**
         * Constructs a new instance of {@link TempDenormalizedVessel}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param vrpStartDateTime Date
         * @param vfStartDateTime Date
         * @param vopStartDateTime Date
         * @param program Program
         * @return newInstance TempDenormalizedVessel
         */
        public static TempDenormalizedVessel newInstance(Date vrpStartDateTime, Date vfStartDateTime, Date vopStartDateTime, Program program)
        {
            final TempDenormalizedVessel entity = new TempDenormalizedVesselImpl();
            entity.setVrpStartDateTime(vrpStartDateTime);
            entity.setVfStartDateTime(vfStartDateTime);
            entity.setVopStartDateTime(vopStartDateTime);
            entity.setProgram(program);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(TempDenormalizedVessel o)
    {
        int cmp = 0;
        if (this.getCode() != null)
        {
            cmp = this.getCode().compareTo(o.getCode());
        }
        else
        {
            if (this.getVrpStartDateTime() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getVrpStartDateTime().compareTo(o.getVrpStartDateTime()));
            }
            if (this.getVfStartDateTime() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getVfStartDateTime().compareTo(o.getVfStartDateTime()));
            }
            if (this.getVopStartDateTime() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getVopStartDateTime().compareTo(o.getVopStartDateTime()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// TempDenormalizedVessel.java merge-point
}